package ai.hotel.entity;

import java.util.Collections;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * This class was automatically generated by the data modeler tool.
 */

public class DBUtil implements java.io.Serializable {

    private static final Logger logger = LoggerFactory.getLogger(DBUtil.class);



    static final long serialVersionUID = 1L;

    public DBUtil() {
    }

	//check if the room exists
    @SuppressWarnings("unchecked")
    public static Boolean doesRoomExists(Integer roomNo) {
        List<String> roomList = new ArrayList<String>();
        Boolean result=false;
        Connection connection=null;
		PreparedStatement statement=null;
        try{
            Class.forName("org.postgresql.Driver");
            connection = DriverManager.getConnection("jdbc:postgresql://localhost:5433/JBPM-DB", "postgres", "rednijet115");
            //create a select statement to get records
			statement = connection.prepareStatement("SELECT * FROM ROOMS WHERE ROOMNO=?");
            statement.setInt(1, roomNo);
            ResultSet rs = statement.executeQuery();
            if (rs!=null && rs.next()){
                result = true;
            } else {
                result = false;
            }
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }finally {
			//close connections
			try{
				if (statement != null) {
					statement.close();
				}
				if (connection != null) {
					connection.close();
				}
			}catch(SQLException se){
			}// do nothing
        }
        return result;
    }
	//get the status of room
    @SuppressWarnings("unchecked")
    public static String getRoomStatus(Integer roomNo) {
        List<String> roomList = new ArrayList<String>();
        String result=null;		
        Connection connection=null;
		PreparedStatement statement=null;
        try{
            Class.forName("org.postgresql.Driver");
            connection = DriverManager.getConnection("jdbc:postgresql://localhost:5433/JBPM-DB", "postgres", "rednijet115");
			//select statement to get status of room
            statement = connection.prepareStatement("SELECT * FROM ROOMS WHERE ROOMNO=?");
            statement.setInt(1, roomNo);
            ResultSet rs = statement.executeQuery();
            if (rs!=null && rs.next()) {
                result = rs.getString("STATUS");
            }
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }finally {
			//close connections
			try{
				if (statement != null) {
					statement.close();
				}
				if (connection != null) {
					connection.close();
				}
			}catch(SQLException se){
			}// do nothing
        }
        return result;
    }
	//To update room with new data
    public static void updateRoom(Integer roomNo, String status, String oldStatus, String des) {
        String[] roomInfoArr = null;
        Connection connection=null;
		PreparedStatement statement=null;
        try {
            Class.forName("org.postgresql.Driver");
            connection = DriverManager.getConnection("jdbc:postgresql://localhost:5433/JBPM-DB", "postgres", "rednijet115");
			//update statement to refresh room data
            statement = connection.prepareStatement("UPDATE ROOMS SET STATUS=?, OLDSTATUS=?, DESCRIPTION=?, TIMESTAMP='"+new java.sql.Timestamp(System.currentTimeMillis())+"' WHERE ROOMNO=?");
            //PreparedStatement statement = connection.prepareStatement("UPDATE ROOMS SET STATUS=? WHERE ROOMNO=?");
            statement.setString(1, status);
            statement.setString(2, oldStatus);
            statement.setString(3, des);
            statement.setInt(4, roomNo);
            statement.executeUpdate();
        } catch (Exception ex) {
            ex.printStackTrace();
        }finally {
			//close connections
			try{
				if (statement != null) {
					statement.close();
				}
				if (connection != null) {
					connection.close();
				}
			}catch(SQLException se){
			}// do nothing
        }
    }
	//method to insert new data into room entity
    public static void insertRoom(Integer roomNo, String status, String OldStatus, String des) {
        String oldStatus = null;
        String[] roomInfoArr = null;
		
        Connection connection=null;
		PreparedStatement statement=null;
        try {
            Class.forName("org.postgresql.Driver");
            connection = DriverManager.getConnection("jdbc:postgresql://localhost:5433/JBPM-DB", "postgres", "rednijet115");
            System.out.println("*************3**************");
            //PreparedStatement statement = connection.prepareStatement("UPDATE ROOMS SET STATUS=?, OLDSTATUS=?, DESCRIPTION=? WHERE ROOMNO=?");
            //statement to insert a new row of room
			statement = connection.prepareStatement("INSERT INTO ROOMS(ID,ROOMNO,STATUS,OLDSTATUS,DESCRIPTION,TIMESTAMP) VALUES(?,?,?,?,?,'"+new java.sql.Timestamp(System.currentTimeMillis())+"')");
            statement.setInt(1, 1);
            statement.setInt(2, roomNo);
            statement.setString(3, status);
            statement.setString(4, oldStatus);
            statement.setString(5, des);
            //statement.setObject(6, dateTime);
            statement.executeUpdate();
        } catch (Exception ex) {
            ex.printStackTrace();
        }finally {
			//close connections
			try{
				if (statement != null) {
					statement.close();
				}
				if (connection != null) {
					connection.close();
				}
			}catch(SQLException se){
			}// do nothing
        }
    }
	
	//for future use for JPA
    @SuppressWarnings("unchecked")
    public void doQuery(String queryName, Object queryParams) {
    }

    public void doCreate(Object entity) {
    }

    public void doUpdate(Object entity) {
    }

    public void doDelete(Object entity) {
    }


}